[Plugin] Hatchfaces (v1.8 beta) UPDATED 15-Dec-2012
-
jolran, a few suggests for you to consider.
-
Seperate out the code that draws the line pattern, into it's own method. That will make your main program simpler to understand. It will look more like an outline. Check out my later example code snippet. I just premade the line pattern, by hand, which would represent simply calling a method to make it. Also, you can reuse the draw_lines method, say if you want to draw a 2nd set in the criss cross direction.
-
Might want to consider a rethink. The program will become more complicated, if you just keep adding stuff on top of exsiting. Here's a possible new way, shown below. And the way I test stuff quickly, is to use the "Ruby Web Console" plugin by Jim Foltz. I often check parts of my program, like this, as snippets of code; before adding it to the plugin. You simply undo <ctrl+z>, change the line(s) of code and execute the code again, by hitting the "eval button".
#This snippet puts the face,lines & hatch into 3 seperate groups. Face is simply grouped, not copied. #The "lines" group is premade and named "lines", so the script can find it. #You need to select the face, before running script #No need to delete seperate edges, just delete the lines group when done. model = Sketchup.active_model ent = model.entities sel = model.selection f = sel[0] face = ent.add_group(f) lines = (ent.to_a.select {|e| e.is_a?(Sketchup;;Group) and e.name=="lines"})[0] puts lines hatch = ent.add_group hent=hatch.entities; lent=lines.entities; fent=face.entities htr=hatch.transformation; ltr=lines.transformation; ftr=face.transformation fent.intersect_with(true, ftr, hent, htr, false, lines) lines.erase! face.explode
![After pressing "eval" button](/uploads/imported_attachments/Hdko_test_hatch_rwc_after.png "After pressing "eval" button")
test_hatch_RubyWebConsole.skp -
-
This is very useful, jolran. Thanks for making it happen.
-
wonderful!! This kind of plugin (hopefully someday with some extra hatch options) is really what I was missing in SU.
Many thanks to those involved!
-
Sergey, thanks for your suggestions I will probably go for something like the picture, first time around.
Unless I'm wrong you have to use webdialog for checkboxes, and I'll put that on hold for now.
More important issues to deal with first.Hi Kyyu. Many thanks for your input and experimenting. Really appreciate it
I got a strong impression from reading this forum, that making groupes from selection is a bad choice?
Thats why I neglected my original idea and went for TIG's "face.clone iterating stuff". Don't you get splats doing it like that? Have you tried this inside a group? I got constant splats doing almost exactly as you did.However grouping the edges before doing an intersect_with might be a good idea. That might actually be an easier method than iteration the edges for erasing? Depends on how "splat-prone" the method is.
About separating to 3 groups. Don't know if that is necessary? Doesent it suffice to add the hatches to a new layer? (Which is already implemented in my current code). This grouping In my opinion does no good for the workflow. Need more feedback about that, please
@unknownuser said:
Seperate out the code that draws the line pattern, into it's own method
Yeah, I know code's a bit messy, but doing a second hatching that is probably a must anyway.
I'm using AS ruby code editor. It's the same as Jim's no?Thank you Jim and Kaas! And TIG's been helping me a LOT, that goes without saying.
-
YES!!!! Faces with holes are hatching now. Will update tomorrow, hopefully.
Stupid newbie-mistake. I did not create "@face" object. So for ex bb=face.bounds
did not have anything to refer to since face was in Faces2go's scope. At least that is what I think happend.Will test more before I celebrate too much...
Sorry TIG, I missed your post from yesterday. I wasent using return nil. I used =begin and =end. That works equally good?
-
Testing.
-
Looking Good
-
Sorry, disregard, was trying to edit the previous post.
-
@jolran said:
YES!!!! Faces with holes are hatching now. Will update tomorrow, hopefully.
So when will come tomorrow? I am looking forward!
I am sure - in the new version of SketchUp this plugin should become a standard feature. -
jolran, looks like you got it working well. So no need to change anything. I will answer the questions, anyways.
@unknownuser said:
Hi Kyyu. Many thanks for your input and experimenting. Really appreciate it
I got a strong impression from reading this forum, that making groupes from selection is a bad choice?
Thats why I neglected my original idea and went for TIG's "face.clone iterating stuff". Don't you get splats doing it like that? Have you tried this inside a group? I got constant splats doing almost exactly as you did.However grouping the edges before doing an intersect_with might be a good idea. That might actually be an easier method than iteration the edges for erasing? Depends on how "splat-prone" the method is.
Yes, it's to be avoided. But you can do it, under certain circumstances. Grouping loose geometry is ok, especially a single edge or face. In my example, I grouped a face at the very beginning. And it do it, just once. I've written plugins, like this, before. You can't do it what an entitiy, already inside a group. I'm assuming it has to be in the current active_entities.
If, I am just testing a quick snippet of code, I certainly will just group the face instead of writing a bunch of lines to clone it.
You only need to consider doing all this, if you didn't make the entitiy. If you want your lines in a group, then you would make an empty group 1st, and then create the lines directly in the group (gents.add_line instead of ents.add_line).
@unknownuser said:
About separating to 3 groups. Don't know if that is necessary? Doesent it suffice to add the hatches to a new layer? (Which is already implemented in my current code). This grouping In my opinion does no good for the workflow. Need more feedback about that, please
It all depends on how you are doing stuff. My thoughts on 3 groups is as follows: Group1 is your cloned face group. If you decide to group your line pattern, then that's group2. When you use intersec_with, you can choose where the new lines go. You can't put them in group1 or group2. They would merge and you have to clean them up. So you put them in group3. Then you only need to delete group1 & group2. No need to find and delete any edges. That's what my example does. Except, I just explode group1, becasue I don't make a clone.
@unknownuser said:
I'm using AS ruby code editor. It's the same as Jim's no?
Should be the same. Just suggesting an editor that can execute the code, if you aren't using one. I use Notepad++ for that and reload using Jim's Ruby Toolbar. But Jim's Ruby Web Console does the undo automatically. And very easy to test small bits of code. I still use his older version.
-Kwok
-
Looking to the future, I regret to foresee, this plugin will be not freeware.
-
Do you have a crystal ball or some sixth sense? Will I be able to cut the grass tomorrow or will it rain?
-
@unknownuser said:
Do you have a crystal ball or some sixth sense?
The really good thing can not be free. It understandable without a crystal ball and without sixth sense.
@unknownuser said:
Will I be able to cut the grass tomorrow or will it rain?
Good question, but a great pity to spend my magical powers to answer it.
-
Ver 1.3 added!
Hole "issue" should work. At least it does for me..
Note. Crosshatching does NOT work yet. Only menu items has been added. Layer Hatching now gets made with hatching in it.
What say you about choice of keeping Face and being able to add material?
This version needs to be tested. Have not recieved feedback from TIG about this update, and that makes me nervous
-
Kyyu! Thank you so much for your detailed explanation. Now I understand better. Much apreciated.
I think your intersect method is worth experimenting with for upcoming features. And or what features is possible.@unknownuser said:
this plugin will be not freeware
No one in here needs to worry this will become a comersial plugin.
Yes, of course I need to make money. But I have gotten so much help from TIG and Kyyu, Jim and others, so going comers. would be HIGHLY unethical! If even legal? This is a great learning experience for me, and I will try too remain humble and listen to
advice and suggestions being made.@unknownuser said:
in the new version of SketchUp this plugin should become a standard feature
Hatches, yes. So this work might be for nothing Although, it is possible only Layout will be the program that get hatches.
-
Yes! It happened!
Even if this is the final version of the plugin - that would be enough.
Many thanks you and those who helped you in this difficult and very necessary work.But I want to go further in my desires
How about this?
-
My comments...
Code like
jol_icons = Sketchup.find_support_file "Plugins/Hatchfaces/hatchfaces_s.png"
etc would be safer as
jol_icons = File.join(File.dirname(__FILE__)), 'Hatchfaces', 'hatchfaces_s.png')
because some users don't/can't put their stuff in the main Plugins folder -Sketchup.find_support_file()
is best avoided.Also how about adding a Plugins [or Tools?] menu item so users can shortcut to it easily...
Enabling the crosshatch options is relatively straight forward...
I would have three questions Angle, Spacing, and Crosshatch?
If the user has said 'Yes' [default='No'] as second dialog opens - the Angle set to the first set angle*-1 and the same Spacing - OK to do crosshatching or Cancel to not do crosshatching...
To process the hatching I'd move that part of the code out to a sub-method that takes several arguments - e.g.def hatch(angle,spacing,gents)
Then if there's no crosshatching you call if once passing the three values so it knows what to make and where to put stuff [gents]... If there is crosshatching it makes the hatch-group and then a group inside that, it runs the hatch sub-method in that sub-group entities... and then adds another sub-group for the crosshatching and runs the hatch sub-method with the new values in the second sub-group entities. This way the two hatches are grouped as one, but in each their own sub-group, so one of them could be erased later if a user desired it... -
It is not the final version There are things to fix. But I'm happy if the plugin is working for you, keep testing.
@unknownuser said:
But I want to go further in my desires
How about this?That can easy be made manualy in Sketchup if you use r.click intersect with selected(face and hatchgroup) so the hatched lines adds to the face. Then go into styles-> edit->profiles, and work with the setting there.
If you want border "thin" faces to be drawn, that's a different issue. This feature in code might not be that easy. I can have a look on that later. First I will try to get the crosshatching working.
One have to consider what feature to add or not. If that feature is 1 click in Sketchup, it might not be worth adding it to the code.
-
@jolran said:
That can easy be made manualy in Sketchup if you use r.click intersect with selected(face and hatchgroup) so the hatched lines adds to the face. Then go into styles-> edit->profiles, and work with the setting there.
Yes. It can be done. But in this case I am losing one large face, and in return get a lot of small faces. Seems to me it is not very well.
-
Ok I see what you mean. I will take a look at that later on. My 1st thought is that it will not be that easy to do.
In native Sketchup just use offset, doing that in code is not that straightforward, from what I know.
Crosshatching is on the next TODO list, and TIG's recommendations for filepaths.
Could spend some time on those...
Advertisement